default:
  image: ubuntu:20.04
  before_script:
      - apt-get update -q -y
      - DEBIAN_FRONTEND=noninteractive apt-get install -y --no-install-recommends tzdata
      - apt list -a libsundials-dev
      - apt-get install -y python3-dev swig libsundials-dev libboost-all-dev python3-pip
      - python3 -V


stages:
  - dependencies
  - unit_tests
  - release


install_dependencies:
    stage: dependencies
    script:
      - pip3 install -U --force-reinstall virtualenv
      - virtualenv venv
      - source venv/bin/activate
      - pip3 install fmipp
      - rm -rf dist
      - rm -rf build
      - python setup.py bdist_wheel sdist
      - pip3 install .
      - pip3 install pytest
    artifacts:
      paths:
       - venv/
       - venv/bin/
       - dist/
       - build/
      expire_in: 60 minutes
    except:
      - tags


unit_tests_cs_v2:
    stage: unit_tests
    script:
      - source venv/bin/activate
      - pytest tests/test_fmuAdapter_cs_v2.py
    except:
      - tags


unit_tests_me_v2:
    stage: unit_tests
    script:
      - source venv/bin/activate
      - pytest tests/test_fmuAdapter_me_v2.py
    except:
      - tags


unit_tests_cs_v1:
    stage: unit_tests
    script:
      - source venv/bin/activate
      - pytest tests/test_fmuAdapter_cs_v1.py
    except:
      - tags


unit_tests_me_v1:
    stage: unit_tests
    script:
      - source venv/bin/activate
      - pytest tests/test_fmuAdapter_me_v1.py
    except:
      - tags


pypi:
  stage: release
  image: python:3.9
  variables:
      TWINE_USERNAME: $MOSAIK_PYPI_USER
      TWINE_PASSWORD: $MOSAIK_PYPI_PASSWORD
  before_script:
      - echo $MOSAIK_PYPI_USER
      - apt-get update -q -y
  script:
      - python -m pip install --quiet --upgrade twine wheel
      - python setup.py check sdist bdist  # This will fail if your creds are bad.
      - rm -rf dist
      - rm -rf build
      - python setup.py sdist bdist_wheel
      - twine check dist/*
      - twine upload --repository-url https://upload.pypi.org/legacy/ --verbose dist/*
  only:
     - tags
